out "/dev/null";
load groebner;
load solve;
load assist;
load roots;
%input_case NIL;
off trigform;
off fullroots;
off arbvars;
precision <<2*user_precision>>;
in "$P4_DIR/reduce/tools.red";
in "$P4_DIR/reduce/find_real_roots.red";
in "$P4_DIR/reduce/type.red";
in "$P4_DIR/reduce/separatrice_test.red";
in "$P4_DIR/reduce/write_to_log.red";
in "$P4_DIR/reduce/blow_up.red";
in "$P4_DIR/reduce/find_inf_points.red";
in "$P4_DIR/reduce/poincare_lyapunov.red";
in "$P4_DIR/reduce/weak_focus.red";
in "$P4_DIR/reduce/gcd2.red";
in "$P4_DIR/reduce/num_coeff.red";
in "$P4_DIR/reduce/behaviour_inf.red";
shut "/dev/null";
%load_package gapds;

if numeric=1 then on rounded;

write "LET US STUDY THE DIFFERENTIAL SYSTEM:";
  write "    x'=",first f;
  write "    y'=",second f;

  openfile(vec_table);
  write all_crit_points;
  write p;
  write q;
  if all_crit_points=3 then
  << write_number(x_min);
     write_number(x_max);
     write_number(y_min);
     write_number(y_max);
  >>;
  out 't;

  % looking for common factors
  if gcf=0 then 
   << %reduce shall look for gcf
      ff:=f;
      f:=my_gcd(first f,second f); 
      gc:=second f; % if gc=1 the the system has a common factor
      gcf:=last f;
      f:=first f;     
   >> 
  else
   << % user gives us the gcf and also the reduced vector field
      gc:=2; % if g=2 the the user give us the common factor 
   >>;  
  write_gcf(gcf);
                 
  openfile(vec_table);
  write_vec_field(f);
  out 't;

% system Hamiltonian ?
if (df(first f,x)+df(second f,y))=0 then
  << write "The system is Hamiltonian";
     hamiltonian:=1;
  >>
  else hamiltonian:=0;
  
  if not member(all_crit_points,{2,3}) then
  <<log_file:=finite_table;
    result_file:=finite_res;
    write "LET US STUDY THE SYSTEM AT THE FINITE REGION";
    write ;
    openfile(result_file);
    write "LET US STUDY THE DIFFERENTIAL SYSTEM:";
    if gc=2 then << write "   x'=",gcf*first f;
                    write "   y'=",gcf*second f;
                 >>
            else << write "    x'=",first ff;
                    write "    y'=",second ff;
                 >> ; 
    write "AT THE FINITE REGION";
    if (gc=1) or ((gc=2) and (gcf neq 1)) then
     <<write "the system has common factor ",gcf;
       write "Hence we shall study the reduced system : ";
       write "     x'=",first f;
       write "     y'=",second f;
     >>; 
    write; write;
    out 't; 
    if numeric=0 then
    <<on ratarg$
      g:=find_real_roots(f)$
     % if (gc neq 1) and (gc neq 2) then write "there is a line of singularities !!, namely ",gc;
      ge:=first g$  % ge:=delete_sing(ge)$
      gn:=second g$  % gn:=delete_sing(gn)$
      openfile(log_file);
      write length(ge)+length(gn);
      out 't;
      for j:=1:length(ge) do type(f,first part(ge,j),second part(ge,j),0)$ %R2-chart = 0
      on rounded,complex$
      off ratarg$
      for j:=1:length(gn) do type(f,first part(gn,j),second part(gn,j),0)$
      off rounded,complex$
      off ratarg$ 
    >>
    else << off ratarg$
            gn:=find_real_roots_numeric(f,x,y)$ % gn:=delete_sing(gn)$
            openfile(log_file);
            write length(gn);
            out 't;
            for j:=1:length(gn) do type(f,first part(gn,j),second part(gn,j),0)$
         >>;
    closefile(log_file);
    closefile(result_file); 
  >>;
   
  %calculate vector field on U1-,U2-,V1-,V2-chart
  % and the critical points 
  if not member(all_crit_points,{1,3}) then
  <<log_file:=infinite_table;
    result_file:=infinite_res;
    write "LET US STUDY THE SYSTEM AT INFINITY";
    write ;
    openfile(result_file);
    write "LET US STUDY THE DIFFERENTIAL SYSTEM:";
    if gc=2 then << write "   x'=",gcf*first f;
                    write "   y'=",gcf*second f;
                 >>
            else << write "    x'=",first ff;
                    write "    y'=",second ff;
                 >> ; 
    write "AT INFINITY";
    if (gc=1) or ((gc=2) and (gcf neq 1)) then
     <<write "the system has common factor ",gcf;
       write "Hence we shall study the reduced system : ";
       write "     x'=",first f;
       write "     y'=",second f;
     >>; 
    write; write;
    out 't;
  >>;
  if numeric=0 then on ratarg$
  if (p=1) and (q=1) then vec_field_diff_chart(f,x,y)
                     else pl_chart(f); 
                             

  if not member(all_crit_points,{1,3}) then
  << closefile(log_file);
     closefile(result_file);
  >>;
  closefile(vec_table);

  % local study of a singular point
  if all_crit_points=3 then 
   <<log_file:=finite_table;
     result_file:=finite_res;
     openfile(log_file);
     write 1; % one singular point
     out 't;
     openfile(result_file);
     write "We shall study the differential system:";
     if gc=2 then << write "  x'=",gcf*first f;
                     write "  y'=",gcf*second f;
                  >>
             else << write "  x'=",first ff;
                     write "  y'=",second ff;
                  >>;
     write "in point (",x0,",",y0,")";
     if (gc=1) or ((gc=2) and (gcf neq 1)) then
     <<write "The system has common factor ",gcf;
       write "Hence we shall study the reduced system :";
       write "     x'=",first f;
       write "     y'=",second f;
     >>;
     write; write;
     out 't;
     type(f,x0,y0,0);
     closefile(log_file);
     closefile(result_file);
  >>;



