procedure real_roots_numeric(f,x);
begin scalar ok,n,k,s,j,a,g,l,b,r,i;
r:=symbolic !*rounded;
on rounded,complex;

on adjprec;
s:=solve(f,x);
off adjprec;
precision <<2*user_precision>>;

g:={}; 
for j:=1:length(s) do
<< a:=rhs part(s,j); 
    if abs(impart(a))<=10^(-user_precision) then 
     << ok:='t; a:=repart(a); i:=0; 
        while ok and (i<length(g))  do
         <<i:=i+1;
           if eeq(a,part(g,i)) then ok:=NIL;
         >>;
         if ok then g:=union(g,{a});
     >>;    
>>;
if not r then off rounded;
off complex;
return g;
end;

procedure find_real_roots_numeric(f,x,y);
begin scalar s,g,j,a,b,a_real,a_imag,b_real,b_imag,ok,l;
on adjprec;
s:=solve(f,{x,y});
off adjprec;
precision <<2*user_precision>>;
g:={}; 
for j:=1:length(s) do
<< if (lhs first part(s,j))=x then
    <<a:=rhs first part(s,j);
      b:=rhs second part(s,j); >>
                              else
    <<b:=rhs first part(s,j);
      a:=rhs second part(s,j); >>;
   a_real:=repart(a); a_imag:=impart(a);
   b_real:=repart(b); b_imag:=impart(b);
       if abs(a_imag)<=10^(-user_precision) and 
          abs(b_imag)<=10^(-user_precision) and
          abs(sub(x=a_real,y=b_real,first f))<=10^(-user_precision) and
          abs(sub(x=a_real,y=b_real,second f))<=10^(-user_precision)
          then << g:=union(g,{{a_real,b_real}}); 
          write a_real," ",b_real," ",sub(x=a_real,y=b_real,f); >>
>>;
return g;
end;


	
procedure find_real_roots(f);
begin scalar j,k,ge,gn,h,n,s1,s2,l,gc;
gc:=1;
h:=solve(f,{x,y}); 
if save_all then <<openfile(result_file);
                   write "======================================================";
                   write "solving the system ",f;
                   write "the roots are ",h;
                   out 't;
                 >>;
ge:={}; gn:={};
for k:=1:length(h) do
 << a:=part(h,k);
    if save_all then <<openfile(result_file);
                       write "checking ",a;
                       out 't;
                     >>;  
%    if length(a)=1 then  <<gc:=gc*(lhs first a-rhs first a);
%                           if save_all then <<openfile(result_file);
%                           write a," is a line of singularities ";
%                           out 't; >>;
%                         >>  
%                           
%     else 
     << if (lhs first a)=x then <<b:=rhs first a; c:=rhs second a;>>
			   else <<b:=rhs second a; c:=rhs first a;>>;	   
	if ((arglength(b)=-1) and (arglength(c)=-1)) then
	 << if (imp(b)=0) and (imp(c)=0) then 
	      <<ge:=append(ge,{{b,c}});
	        if save_all then 
	         <<openfile(result_file);
	           write "(",b,",",c,") is a real root.";
	           out 't;
	         >>
	      >>
	    else if save_all then <<openfile(result_file);
	                            write "(",b,",",c,") is a complex root.";
	                            out 't;
	                          >>                                                 
         >>
        else if ((arglength(b) neq -1) and (arglength(c)=-1)) then
           <<if (imp(c)=0) and (part(b,0)='root_of) then 
	    << if save_all then 
	          <<openfile(result_file);
	            write "try to solve the equation ",b,"numerically.";
	            out 't;
	          >>;   
	       s:=real_roots_numeric(part(b,1),part(b,2));
               for j:=1:length(s) do 
		<< let x=part(s,j);
		   gn:=append(gn,{{part(s,j),c}});
		   clear x;
                >>
	    >>
           else
            if (imp(b)=0) and (imp(c)=0) then ge:=append(ge,{{b,c}});
         >>
        else if ((arglength(b)=-1) and (arglength(c) neq -1)) then
           <<if (imp(b)=0) and (part(c,0)='root_of) then
	    << if save_all then
	          <<openfile(result_file);
	            write "try to solve the equation ",c,"numerically.";
	            out 't;
	          >>;
	       s:=real_roots_numeric(part(c,1),part(c,2));
	       for j:=1:length(s) do 
	       << let y=part(s,j);
		  gn:=append(gn,{{b,part(s,j)}});
		  clear y;
               >>
            >>
           else
	     if (imp(b)=0) and (imp(c)=0) then 
	     << if save_all then
	        <<openfile(result_file);
	          write "(",b,",",c,") is a real root";
	          out 't;
	        >>;  
	        ge:=append(ge,{{b,c}});
	     >>   
         >>
        else if part(b,0)='x then
         <<if part(c,0)='root_of then gc:=gc*sub(y_=y,part(c,1))
           else gc:=gc*(y-c)
         >>
        else if part(c,0)='y then
         <<if part(b,0)='root_of then gc:=gc*sub(x_=x,part(b,1))
           else gc:=gc*(x-b)
         >>
        else if (part(b,0) neq 'root_of) and (part(c,0) neq 'root_of) then
	 <<if (imp(b)=0) and (imp(c)=0) then ge:=append(ge,{{b,c}});
         >>
        else if (part(b,0)='root_of) and (part(c,0) neq 'root_of) then
	 <<s:=real_roots_numeric(part(b,1),part(b,2));
	   for j:=1:length(s) do
	   << let x=part(s,j);
	       if imp(c)=0 then gn:=append(gn,{{part(s,j),c}});
	      clear x;
           >>
         >>
        else if (part(b,0) neq 'root_of) and (part(c,0)='root_of) then
	 << s:=real_roots_numeric(part(c,1),part(c,2));
	    for j:=1:length(s) do
	    << let y=part(s,j); 
	        if imp(b)=0 then gn:=append(gn,{{b,part(s,j)}});
	       clear y;
            >>
         >>
        else
	 << s1:=real_roots_numeric(part(b,1),part(b,2));
	    s2:=real_roots_numeric(part(c,1),part(c,2));
	    for j:=1:length(s1) do
	    << let x=part(s1,j);
	       for l:=1:length(s2) do
	       << let y=part(s2,l);
		  gn:=append(gn,{{b,c}});
		  clear y;
               >>;
               clear x;
            >>
         >>
     >>;
  >>;
if save_all then <<openfile(result_file);
                   write "the exact real roots of the system are ",ge;
                   on rounded;
                   write "the numerical real roots of the system are ",gn;
                   off rounded;
                   write "======================================================";
                 >>;  
return <<{ge,gn,gc}>>;
end;

procedure find_real_roots1(f,x);
begin scalar gn,ge,h,a,b,k;
if symbolic !*rounded then 
 return({{},real_roots_numeric(f,x)});
h:=solve(f,x);
ge:={}; gn:={};
for k:=1:length(h) do
<< a:=part(h,k);
   b:=rhs a;
   if arglength(b)=-1 then
    <<  if imp(b)=0 then ge:=append(ge,{b})
    >>
   else if part(b,0)='root_of then
    gn:=append(gn,real_roots_numeric(part(b,1),part(b,2)))
   else if imp(b)=0 then ge:=append(ge,{b})
   
>>;
return {ge,gn};
end;


