procedure determine_p_q(f);
begin scalar p1,q1,g,n_d,g1,q_degree,d,r;
r:=symbolic !*rounded;
d:=max(ddeg(first f,x,y),ddeg(second f,x,y));
p1:=sub(x=x/(x^2+y^2),y=y/(x^2+y^2),first f);
q1:=sub(x=x/(x^2+y^2),y=y/(x^2+y^2),second f);
g:={(x^2+y^2)^d*(p1*(y^2-x^2)-2*q1*x*y),
    (x^2+y^2)^d*(q1*(x^2-y^2)-2*p1*x*y)};
write g;
off rounded;
n_d:=newton_diagram(g);
g1:=gamma1(n_d);
q_degree:=quasi_degree(g1);
if r then on rounded;
write g;
write q_degree;
%return {first q_degree,second q_degree};
end;

procedure pl_chart(f);
begin scalar c,f_U1,f_V1,f_U2,f_V2,h,g,f_c,ge,gn,
             j,ro;

clear z1,z2,d;

if (all_crit_points neq 1) and (all_crit_points neq 3) then
<<
  write "we make the study on the Poincare-Lyapunov disc of degree (",p,",",q,")";
  openfile(result_file);
  write "we make the study on the Poincare-Lyapunov disc of degree (",p,",",q,")";
  out 't;
>>;

c:=quasi_homogeneous_degree(f,p,q);
g:=z2^q*sub(x=d/z2^p,y=z1/z2^q,second f)-d*q/p*z2^p*z1*sub(x=d/z2^p,y=z1/z2^q,first f);
h:=-d/p*z2^(p+1)*sub(x=d/z2^p,y=z1/z2^q,first f);
f_U1:=sub(d=1,{g*z2^c,h*z2^c});
f_V1:=sub(d=-1,{g*z2^c,h*z2^c});

g:=z2^p*sub(x=z1/z2^p,y=d/z2^q,first f)-d*p/q*z2^q*z1*sub(x=z1/z2^p,y=d/z2^q,second f);
h:=-d/q*z2^(q+1)*sub(x=z1/z2^p,y=d/z2^q,second f);
f_U2:=sub(d=1,{g*z2^c,h*z2^c});
f_V2:=sub(d=-1,{g*z2^c,h*z2^c});


% writing the different vector fields to log_file
openfile(vec_table);
write_vec_field(sub(z1=x,z2=y,f_U1));
write_vec_field(sub(z1=x,z2=y,f_V1));
write_vec_field(sub(z1=x,z2=y,f_U2));
write_vec_field(sub(z1=x,z2=y,f_V2));

% evaluate vector field on the cylinder
clear r,Co,Si;
g:=-r^(p+1)*Co*sub(x=Co/r^p,y=Si/r^q,first f)-r^(q+1)*
     Si*sub(x=Co/r^p,y=Si/r^q,second f);
h:=(-q*r^(p+1)*Si*sub(x=Co/r^p,y=Si/r^q,first f)+p*r^(q+1)*Co*
    sub(x=Co/r^p,y=Si/r^q,second f))/r;
f_C:={g*r^c,h*r^c};
write_vec_field_cylinder(f_C);
out 't;



if (all_crit_points neq 1) and (all_crit_points neq 3) then
<<

%find roots of f_U1
g:=find_real_roots1(sub(z2=0,first f_U1),z1);
ge:=first g;
gn:=second g;
openfile(log_file);
write length(ge)+length(gn);
out 't;
write "THE DIFF SYSTEM ON THE U1-CHART:";
write "z1'=",first f_U1;
write "z2'=",second f_U1;
openfile(result_file);
write "First we study the system on the U1-chart (x=1/z2^",p,",y=z1/z2^",q,")";
write "z1'=",first f_U1;
write "z2'=",second f_U1;
out 't;
for j:=1:length(ge) do
<< a:=part(ge,j);
   type_inf(f_U1,1,a,sub(z1=a,z2=0,df(first f_U1,z1)),
            sub(z1=a,z2=0,df(first f_U1,z2)),sub(z1=a,z2=0,df(second f_U1,z2)),0);
>>;
ro:=symbolic !*rounded;
on rounded;
for j:=1:length(gn) do
<< a:=part(gn,j);
   type_inf(f_U1,1,a,sub(z1=a,z2=0,df(first f_U1,z1)),
            sub(z1=a,z2=0,df(first f_U1,z2)),sub(z1=a,z2=0,df(second f_U1,z2)),0);
>>;
if not ro then off rounded;

%find roots of f_V1
g:=find_real_roots1(sub(z2=0,first f_V1),z1);
ge:=first g;
gn:=second g;
openfile(log_file);
write length(ge)+length(gn);
out 't;
write "THE DIFF SYSTEM ON THE V1-CHART:";
write "z1'=",first f_V1;
write "z2'=",second f_V1;
openfile(result_file);
write "Now we study the system on the V1-chart (x=-1/z2^",p,",y=z1/z2^",q,")";
write "z1'=",first f_V1;
write "z2'=",second f_V1;
out 't;
for j:=1:length(ge) do
<< a:=part(ge,j);
   type_inf(f_V1,3,a,sub(z1=a,z2=0,df(first f_V1,z1)),
            sub(z1=a,z2=0,df(first f_V1,z2)),sub(z1=a,z2=0,df(second f_V1,z2)),0);
>>;
on rounded;
for j:=1:length(gn) do
<< a:=part(gn,j);
   type_inf(f_V1,3,a,sub(z1=a,z2=0,df(first f_V1,z1)),
            sub(z1=a,z2=0,df(first f_V1,z2)),sub(z1=a,z2=0,df(second f_V1,z2)),0);
>>;
if not ro then off rounded;

% (0,0) a root of f_U2 ?
if eeq(sub(z1=0,z2=0,first f_U2),0) and eeq(sub(z1=0,z2=0,second f_U2),0) then
 <<openfile(log_file);
   write 1;
   out 't;
   write "THE DIFF SYSTEM ON THE U2-CHART:";
   write "z1'=",first f_U2;
   write "z2'=",second f_U2;
   openfile(result_file);
   write "Now we study the system on the U2-chart (x=z1/z2^",p,",y=1/z2^",q,")";
   write "z1'=",first f_U2;
   write "z2'=",second f_U2;
   write "(0,0) is a singular point of the vector field";
   out 't;
   type_inf(f_U2,2,0,sub(z1=0,z2=0,df(first f_U2,z1)),
     sub(z1=0,z2=0,df(first f_U2,z2)),sub(z1=0,z2=0,df(second f_U2,z2)),0);
 >>
else <<openfile(log_file);
       write 0;
       out 't;
     >>;

% (0,0) a root of f_V2 ?
if eeq(sub(z1=0,z2=0,first f_V2),0) and eeq(sub(z1=0,z2=0,second f_V2),0) then
 <<openfile(log_file);
   write 1;
   out 't;
   write "THE DIFF SYSTEM ON THE V2-CHART:";
   write "z1'=",first f_V2;
   write "z2'=",second f_V2;
   openfile(result_file);
   write "Now we study the system on the V2-chart (x=z1/z2^",p,",y=-1/z2^",q,")";
   write "z1'=",first f_V2;
   write "z2'=",second f_V2;
   write "(0,0) is a singular point of the vector field";
   out 't;
   type_inf(f_V2,4,0,sub(z1=0,z2=0,df(first f_V2,z1)),
     sub(z1=0,z2=0,df(first f_V2,z2)),sub(z1=0,z2=0,df(second f_V2,z2)),0);
 >>
else <<openfile(log_file);
       write 0;
       out 't;
     >>;

>>;
end;
