procedure write_number(a);
begin
if a>=0 then write a
        else write "-",abs(a);
end;
 
procedure openfile(file);
begin
 out file;
end;

procedure closefile(file);
begin
  shut file;
end;

procedure evalf(a);
begin scalar b;
if symbolic !*rounded then return a;
on rounded;
 b:=a;
off rounded;
return b;
end;

procedure llt(a,b);
begin scalar s,r;
s:='t;
r:=symbolic !*rounded;
on rounded;
if (a-b)>-10**(-user_precision) then s:=NIL;
if not r then off rounded;
return s;
end;

procedure gt(a,b);
begin scalar s,r;
s:='t;
r:=symbolic !*rounded;
on rounded;
if (a-b)<10**(-user_precision) then s:=NIL;
if not r then off rounded;
return s;
end;

procedure gteq(a,b);
begin scalar s,r;
s:='t;
r:=symbolic !*rounded;
on rounded;
if (a-b)<-10**(-user_precision) then s:=NIL;
if not r then off rounded;
return s;
end;

procedure eeq(a,b);
begin scalar s,r;
s:='t; 
r:=symbolic !*rounded;
on rounded;
if abs(a-b)>=(10**(-user_precision)) then s:=NIL;
if not r then off rounded;
return s;
end;

procedure nneq(a,b);
begin scalar s,r;
s:='t;
r:=symbolic !*rounded;
on rounded;
if abs(a-b)<10**(-user_precision) then s:=NIL;
if not r then off rounded;
return s;
end;

procedure first_term(f,x);
begin scalar l,s,g,ok;
s:=coeff(f,x);
l:=1;
ok:=1;
while (ok=1) and (l<=length(s)) do
<< s1:=part(s,l);
   if evalf(s1) neq 0 then << g:=s1*x^(l-1); ok:=0;>>;
   l:=l+1;
>>;
if ok=1 then g:=0;
return g;
end;

procedure lleadterm(f,x);
begin scalar d;
d:=deg(f,x);
if d=0 then return f
       else return lterm(f,x);
end;


procedure nlterm(f,x,y);
begin scalar g,h;
g:=lleadterm(f,x);
if g neq 0 then
<<h:=lleadterm(g,y);
  if h neq 0 then return h
	     else return g
>>
else
<<g:=lleadterm(f,y);
  if g neq 0 then return g
	     else return f>>;
end;

procedure ddeg(f,x,y);
begin scalar g,h,d,r;
r:=symbolic !*rounded;
on rounded; on ratarg;
g:=f; 
d:=0;
while g neq 0 do
<< h:=nlterm(g,x,y);
   d:=max(d,deg(h,x)+deg(h,y));
   g:=g-h; 
>>;
if not r then off rounded;
off ratarg;
return d;
end;

procedure low_ddeg(f,x,y);
begin scalar g,h,d,r;
r:=symbolic !*rounded;
on rounded; on ratarg;
g:=f;
h:=nlterm(g,x,y);
d:=deg(h,x)+deg(h,y);
g:=g-h;
while g neq 0 do
<< h:=nlterm(g,x,y);
   d:=min(d,deg(h,x)+deg(h,y));
   g:=g-h;
>>;
if not r then off rounded;
off ratarg;
return d;
end;


procedure extgcd(q,r,x);
begin scalar a1,a2,b1,b2,h1,h2,s;
if deg(q,x)<deg(r,x) then
<< s:=q; q:=r; r:=s;
   a1:=0; a2:=1; b1:=1; b2:=0
>>
else
<< a1:=1; a2:=0; b1:=0; b2:=1>>;
while r neq 0 do
<< t:=preduce(q,{r},{x}); write t;
   on gcd;
   s:=(q-t)/r;
   off gcd;
   h1:=a1-s*b1;
   h2:=a2-s*b2;
   q:=r; r:=t;
   a1:=b1; a2:=b2; b1:=h1; b2:=h2
>>;
d:=lcof(q,x);
on gcd;
if d neq 0 then <<q:=q/d; a1:=a1/d; a2:=a2/d >>
	   else <<a1:=a1/q; a2:=a2/q; q:=1>>;
off gcd;
return {q,a1,a2};
end;

procedure nterm(f,x,y,d);
begin scalar j,g;
g:=0;
for j:=0:d do
 g:=g+coeffn(coeffn(f,x,j),y,d-j)*x**j*y**(d-j);
return g;
end;

% if in rounded mode then look which coeff of f has absolute value less 
% then precision

procedure change_poly(f);
begin scalar g,h,k,a;

g:=f;
h:=0;
while (g neq 0) do
 << k:=nlterm(g,x,y); 
    a:=coeffn(coeffn(k,x,deg(k,x)),y,deg(k,y));
    if abs(a)>10^(-user_precision) then h:=h+k;
    g:=g-k;
  >>;
return h;
end;

procedure imp(a);
begin scalar b;

if symbolic !*rounded then return impart(a);
on rounded;
on adjprec;
b:=impart(a);
off adjprec;
off rounded;
precision <<2*user_precision>>;
return b;
end;

procedure conj(z); sub(i=-i,z);
procedure re(z); (z+conj(z))/2;
procedure im(z); (z-conj(z))/(2*i);


procedure sort_list(s);
begin scalar h,l,j,a,b,ok;
h:={first s};
for l:=2:length(s) do
<< j:=1; ok:=NIL;
   a:=part(s,l);
   while (j<=length(h)) and (not ok) do
   << b:=part(h,j);
      if first a < first b then << ok:='t; h:=insert(a,h,j); >>
      else 
       if first a = first b then 
        if second a < second b then << ok:='t; h:=insert(a,h,j); >>;
      j:=j+1;
   >>;
   if not ok then h:=append(h,{a});
>>;
return h;
end;

procedure low_deg1(f,x);
begin scalar g,d,r;
r:=symbolic !*rounded;
on rounded;
d:=deg(f,x);
if d neq 0 then
<< g:=f;
   while g neq 0 do
   << h:=lterm(g,x);
      if deg(h,x)<d then d:=deg(g,x);
      g:=g-h;
   >>;
>>;
if not r then off rounded;
return d;
end;

procedure quasi_homogeneous_degree(f,p,q);
begin scalar g,r,c,d;
r:=symbolic !*rounded;
on rounded;
c:=-1;
g:=first f;
while g neq 0 do
<< h:=nlterm(g,x,y);
   g:=g-h;
   d:=p*deg(h,x)+q*deg(h,y)-p;
   if d>c then c:=d;
>>;
g:=second f;
while g neq 0 do
<< h:=nlterm(g,x,y);
   g:=g-h;
   d:=p*deg(h,x)+q*deg(h,y)-q;
   if d>c then c:=d;
>>;
return c;
end;

         