procedure weak_focus(f,x0,y0,chart);
begin scalar ff,aa10,aa01,bb10,s,trans,g,gg,r,type,lyp;

clear z,w;
write "(",x0,",",y0,") is a weak focus";
openfile(result_file);
write "(",x0,",",y0,") is a weak focus";
out 't;

if hamiltonian=1 then 
  << write "Since the system is Hamiltonian, we have a center";
     openfile(result_file);
     write "Since the system is Hamiltonian, we have a center";
     type:=4;
 >>
else
<<
% move point to the origin
% make a transformation of the form
% xx=(-b10*x+a10*y)/sqrt(-a01*b10-a10**2)
% yy=y
% tt=-t*sqrt(-a01*b10-a10**2)
%going in rounded mode

r:=symbolic !*rounded;
on rounded;
on ratarg;

ff:=translation(f,x0,y0);
aa10:=coeffn(coeffn(first ff,x,1),y,0);
aa01:=coeffn(coeffn(first ff,x,0),y,1);
bb10:=coeffn(coeffn(second ff,x,1),y,0);
s:=sqrt(-aa01*bb10-aa10*aa10);
g:={bb10*sub({x=-s*x/bb10+aa10*y/bb10},first ff)/s^2
    -aa10*sub({x=-s*x/bb10+aa10*y/bb10},second ff)/s^2,
    -sub({x=-s*x/bb10+aa10*y/bb10},second ff)/s};
    write g;
gg:=sub({x=(z+w)/2,y=-i*(z-w)/2},first g)+
    i*sub({x=(z+w)/2,y=-i*(z-w)/2},second g);


if save_all then <<openfile(result_file);
                   write "z'=",gg;
                   out 't;
                 >>;

lyp:=lyapunov(gg-i*z);
write lyp;

if first lyp neq 0 then
<< write "order of weakness is ",second lyp;
   write "lyapunov coeff is ",- first lyp;
   openfile(result_file);
   write "order of weakness is ",second lyp;
   write "lyapunov coeff is ",- first lyp;
   out 't;
   if first lyp<0 then << write "We have a unstable singularity";
                          openfile(result_file);
                          write "We have a unstable singularity";
                          out 't;
                          type:=1;
                       >>   
            else << write "We have a stable singularity"; 
                    openfile(result_file);
                    write "We have a stable singularity";
                    out 't;
                    type:=-1;
                 >>;
>>
else
if third lyp=2 or last lyp=1 then << write "We have a centre ";
                          openfile(result_file);
                          write "We have a centre";
                          out 't;
                          type:=4;
                       >>                
       else << write "The order of weakness is at least ", weakness_level+1;
               openfile(result_file);
               write "The order of weakness is at least ", weakness_level+1;
               out 't;
               type:=0;
            >>;  
            
if not r then off rounded;
>>;
openfile(result_file);
write "######################################################################################";
out 't;
write_weak_focus(x0,y0,chart,type);
off ratarg;
end;

%calculate the lyapunov coefficient in C
procedure lyapunov(f);
begin scalar d,l,tempfilename,j,a,file1,file2,type,cubic;

cubic:=0;
tempfilename:= symbolic bldmsg("P4_LYAPUNOV%w",
                 random (100*hash!-function date!-and!-time()));
file1:= symbolic bldmsg("%w.input",tempfilename);
file2:= symbolic bldmsg("%w.output",tempfilename);
openfile(file1);
d:=ddeg(f,z,w); 
if d=2 then write 3  % we have a quadratic system
 else if d=3 then << if coeffn(coeffn(f,z,2),w,0)=0 and 
                        coeffn(coeffn(f,z,0),w,2)=0 and
                        coeffn(coeffn(f,z,1),w,1)=0 then
                        % we have a lin+cubic homogeneous system
                      << write 5; cubic:=1; >>
                      else write weakness_level
                  >>    
 else write weakness_level;
write 10^(-user_precision);
l:=coeff_degree2(f,z,w);
write length(l);
for j:=1:length(l) do
<< a:=part(l,j);
   write first a;
   write second a;
   write_number(repart last a);
   write_number(impart last a);
>>;
closefile(file1);
system symbolic bldmsg("%w/bin/lyapunov %w %w",getenv("P4_DIR"),
 file1,file2);

% read in the results form C 
in file2;
system symbolic bldmsg("rm %w",file1);
system symbolic bldmsg("rm %w",file2);
return({lyp,w,d,cubic});
end;
