; InstallP4.nsi
;
; This script is used by the NUllSoft Install System,
; which can be downloaded for free.
;
; Once NullSoft is installed, just right-click on the
; name of this file in the Windows explorer, and choose
; to Compile the Script.  This will create InstallP4.exe
; which can be distributed.
;
; NOTE:
;   THE SCRIPT ASSUMES THAT YOU HAVE COPIED THE NECESSARY DLL'S
;   FROM MINGW AND QT TO THE BIN SUBDIRECTORY OF THE P4 DISTRIBUTION.
;
;--------------------------------

Name "Polynomial Planar Phase Portraits"

OutFile "InstallP4.exe"
Icon "..\bin\p4icon.ico"
InstallDir $PROGRAMFILES\P4
InstallDirRegKey HKLM "Software\P4" "Install_Dir"

;--------------------------------

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "P4"

  SectionIn RO
  
  ; Set output path to the installation directory.
  CreateDirectory "$INSTDIR\bin"
  CreateDirectory "$INSTDIR\bin\imageformats"
  CreateDirectory "$INSTDIR\help"
  CreateDirectory "$INSTDIR\sumtables"
  CreateDirectory "$DOCUMENTS\P4 Vector Fields"

  SetOutPath $INSTDIR\bin
  
  File "..\bin\*.exe"
  File "..\bin\*.dll"
  File "..\bin\*.m"
  File "..\bin\*.ico"
  File "..\bin\p4smallicon.png"
  File "..\bin\portrait.png"

  SetOutPath $INSTDIR\bin\imageformats

  File "..\bin\imageformats\*.dll"

  SetOutPath $INSTDIR\help
  
  File "..\help\*.*"
  
  WriteRegStr HKLM SOFTWARE\P4 "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P4" "DisplayName" "Polynomial Planar Phase Portraits (P4)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P4" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P4" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P4" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\P4"
  SetOutPath "$DOCUMENTS\P4 Vector Fields"
  CreateShortCut  "$SMPROGRAMS\P4\Polynomial Planar Phase Portraits.lnk" "$INSTDIR\bin\p4.exe" "" "" 0
  SetOutPath $INSTDIR
  CreateShortCut  "$SMPROGRAMS\P4\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0

SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P4"
  DeleteRegKey HKLM SOFTWARE\P4
  DeleteRegKey HKCU SOFTWARE\P4

  ; Remove files and uninstaller
  Delete $INSTDIR\p4.nsi
  Delete $INSTDIR\uninstall.exe

  Delete $INSTDIR\help\*.*
  Delete $INSTDIR\bin\imageformats\*.*
  Delete $INSTDIR\bin\*.*
  Delete $INSTDIR\sumtables\*.*
  Delete $INSTDIR\vectorfields\*.*

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\P4\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\P4"

  RMDir "$INSTDIR\help"
  RMDir "$INSTDIR\bin\imageformats"
  RMDir "$INSTDIR\bin"
  RMDir "$INSTDIR\sumtables"
  RMDir "$INSTDIR\vectorfields"
  RMDir "$INSTDIR"

SectionEnd
