#include <qmainwindow.h>

class QFindDlg;
class QLineEdit;
class QPushButton;
class QBoxLayout;
class QListWidget;
class QListWidgetItem;
class QWinInputSphere;
class QFindDlg;
class QLabel;
class QViewDlg;

class QCurvesDlg : public QWidget
{
    Q_OBJECT

public:
    QCurvesDlg( QFindDlg * startwindow );
    ~QCurvesDlg();
    void GetDataFromDlg( void );
    void UpdateDlgData( void );
    void Signal_CurvesEvaluated( void );

private:
    QFindDlg * parent;
    QBoxLayout * mainLayout;

    QLabel * lbl_status;
    QViewDlg * ViewParams_Window;
    
    QPushButton * btn_add;
    QPushButton * btn_del;
    QPushButton * btn_edit;
    QListWidget * lst_curves;
    QListWidget * lst_vfs;
    QWinInputSphere * isphere;
    QPushButton * btn_refresh;
    QPushButton * btn_eval;
    QPushButton * btn_mark;
    QPushButton * btn_unmark;
    QPushButton * btn_resetmarks;
    QLabel * lbl_vf_or_curves;
    QLabel * lbl_info;
    QPushButton * btn_view;
    QPushButton * btn_zoomout;
    QLabel * lbl_numpoints;
    QLineEdit * edt_numpoints;
    
    bool markingvf;
    bool marking;

public:
    void MakeZoom( double, double, double, double );
    void OnMouseClickLeft( double, double, double );
    void OnMouseClickRight( double, double, double );

public slots:
    void OnBtnZoomOut( void );
    void OnBtnAdd(void );
    void OnBtnDel(void );
    void OnBtnEdit( void );
    void OnNumpointsEditingFinished( void );
    
    void OnBtnMarkToggled( bool );
    void OnBtnUnmarkToggled( bool );
    void OnBtnResetMarks( void );
    void OnBtnView( void );
    void OnBtnEval( void );
    void OnBtnRefresh( void );

    void OnCurvesClicked(QListWidgetItem *);
    void OnVfsClicked(QListWidgetItem *);
    void OnVfsItemActivated(QListWidgetItem *);
    void OnCurvesItemActivated(QListWidgetItem *);
    void OnCurveChanged( QListWidgetItem * );
    void OnCurvesSelectionChanged( void );
    void OnVfsSelectionChanged( void );
};
