#include <qwidget.h>

class QVFParams;
class QFindDlg;
class QBoxLayout;
class QLineEdit;
class QSpinBox;
class QScrollBar;
class QHBoxLayout;
class QLabel;

#ifndef MAXNUMPARAMSSHOWN
#include "custom.h"
#endif

class QVectorFieldDlg : public QWidget
{
    Q_OBJECT

public:
    QVectorFieldDlg( QFindDlg * startwindow );
    void GetDataFromDlg( void );
    void UpdateDlgData( void );
    ~QVectorFieldDlg();

    bool GetLineEditCommonValue( QLineEdit *, QString * * );
    void SetLineEditCommonValue( QLineEdit *, QString * * );

private:
    QBoxLayout * mainLayout;
    QFindDlg * parent;
    QLineEdit * edt_xprime;
    QLineEdit * edt_yprime;
    QLineEdit * edt_gcf;
    QSpinBox * spin_numparams;
    QHBoxLayout * paramLayout;
    QScrollBar * sb_params;
    QVFParams * params;

public slots:
    void numParamsChanged( int );
    void xdot_editingFinished( void );
    void ydot_editingFinished( void );
    void gcf_editingFinished( void );
};

class QVFParams : public QWidget
{
    Q_OBJECT

public:
    QVFParams( QVectorFieldDlg * parent, QScrollBar * sb );
    ~QVFParams();
    bool GetDataFromDlg( void );
    bool UpdateDlgData( void );

private:
    int currentnumparams;
    int currentshownparams;
    int currentpageindex;

    bool GetLineEditCommonParvalue( QLineEdit *, int index );
    void SetLineEditCommonParvalue( QLineEdit *, int index );


    QScrollBar * sb_params;
    QBoxLayout * mainLayout;
    QBoxLayout * superLayout;

    QHBoxLayout * lay_parvalue[MAXNUMPARAMSSHOWN];
    QLineEdit * edt_parlabel[MAXNUMPARAMSSHOWN];
    QLabel * lbl_parequal[MAXNUMPARAMSSHOWN];
    QLineEdit * edt_parvalue[MAXNUMPARAMSSHOWN];

protected:
    bool focusNextPrevChild ( bool next );

public slots:
    void paramsSliderChanged( int );
    void params_editingFinished( void );
};

