; InstallP5.nsi
;
; This script is used by the NUllSoft Install System,
; which can be downloaded for free.
;
; Once NullSoft is installed, just right-click on the
; name of this file in the Windows explorer, and choose
; to Compile the Script.  This will create InstallP5.exe
; which can be distributed.
;
; NOTE:
;   THE SCRIPT ASSUMES THAT YOU HAVE COPIED THE NECESSARY DLL'S
;   FROM MINGW AND QT TO THE BIN SUBDIRECTORY OF THE P5 DISTRIBUTION.
;
;--------------------------------

Name "Piecewise Polynomial Planar Phase Portraits"

OutFile "InstallP5.exe"
Icon "..\bin\p5icon.ico"
InstallDir $PROGRAMFILES\P5
InstallDirRegKey HKLM "Software\P5" "Install_Dir"

;--------------------------------

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "P5"

  SectionIn RO
  
  ; Set output path to the installation directory.
  CreateDirectory "$INSTDIR\bin"
  CreateDirectory "$INSTDIR\bin\imageformats"
  CreateDirectory "$INSTDIR\help"
  CreateDirectory "$INSTDIR\help\images"
  CreateDirectory "$INSTDIR\sumtables"
  CreateDirectory "$DOCUMENTS\P5 Vector Fields"

  SetOutPath $INSTDIR\bin
  
  File "..\bin\*.exe"
  File "..\bin\*.dll"
  File "..\bin\*.m"
  File "..\bin\*.ico"
  File "..\bin\p5smallicon.png"
  File "..\bin\portrait.png"

  SetOutPath $INSTDIR\bin\imageformats

  File "..\bin\imageformats\*.dll"

  SetOutPath $INSTDIR\help
  
  File "..\help\*.*"

  SetOutPath $INSTDIR\help\images

  File "..\help\images\*.*"
  
  WriteRegStr HKLM SOFTWARE\P5 "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P5" "DisplayName" "Piecewise Polynomial Planar Phase Portraits (P5)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P5" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P5" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P5" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\P5"
  SetOutPath "$DOCUMENTS\P5 Vector Fields"
  CreateShortCut  "$SMPROGRAMS\P5\Piecewise Polynomial Planar Phase Portraits.lnk" "$INSTDIR\bin\P5.exe" "" "" 0
  SetOutPath $INSTDIR
  CreateShortCut  "$SMPROGRAMS\P5\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0

SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\P5"
  DeleteRegKey HKLM SOFTWARE\P5
  DeleteRegKey HKCU SOFTWARE\P5

  ; Remove files and uninstaller
  Delete $INSTDIR\P5.nsi
  Delete $INSTDIR\uninstall.exe

  Delete $INSTDIR\help\*.*
  Delete $INSTDIR\bin\imageformats\*.*
  Delete $INSTDIR\bin\*.*
  Delete $INSTDIR\sumtables\*.*
  Delete $INSTDIR\vectorfields\*.*

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\P5\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\P5"

  RMDir "$INSTDIR\help\images"
  RMDir "$INSTDIR\help"
  RMDir "$INSTDIR\bin\imagesformats"
  RMDir "$INSTDIR\bin"
  RMDir "$INSTDIR\sumtables"
  RMDir "$INSTDIR\vectorfields"
  RMDir "$INSTDIR"

SectionEnd
